Subject: Re: [PATCH] glossary: add "remote" and "submodule"

From: Junio C Hamano <[email-masked]>
Date: Wed, 27 May 2015 16:05:31 -0700

Stefan Beller <[email-masked]> writes:

>>> +[[def_submodule]]submodule::
>>> +     A <<def_repository,repository>> inside another repository. The two
>>> +     repositories have different history, though the outer repository
>>> +     knows the commit of the inner repository.
>>
> ... But correctness trumps brevity indeed.

I do not think the correct way is that much longer, though.

A repository inside another repository. The two repositories have different history
A repository that holds the history of a separate project inside another repository

Heh, they are the same length, no?

>
>>
>>        A repository that holds the history of a separate project
>>        inside another repository (the latter of which is called
>>        superproject).
>
> This is better than what I proposed, but confusing. When naming
> a project a submodule, my mental standpoint is the superproject.
> ("This project has the submodule foo and bar"). But In your description
> the superproject is called "another repository".

That is because you are adding an entry for "submodule" to the
glossary, no?  I was writing from submodule's point of view, i.e. "I
(submodule) is inside another repository, and my project is separate
from that other repository's".

>>        The containing superproject knows about the
>>        names of (but does not hold copies of) commit objects of the
>>        contained submodules.
>
> That makes sense to point out here. Though should we also introduce
> "superproject" now?

Yes, that is what I was hinting at.